'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

/**
 * Assert that a saga equals X
 */
exports.default = function (actual, effects) {
    var result = void 0;

    // If we provided specific results to test against
    // use those instead of a snapshot
    if (typeof effects !== 'undefined') {
        var _ret = function () {
            var next = actual.next();

            return {
                v: effects.forEach(function (effect) {
                    expect(next.value).toEqual(effect.action);
                    next = actual.next(effect.response);
                })
            };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    }

    // Else test against a snapshot
    var actions = [];
    do {
        result = actual.next();
        if (!result.done) {
            actions.push(result);
        }
    } while (!result.done);

    expect(actions).toMatchSnapshot();
};