'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.reducerTestFactory = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _assertions = require('../assertions');

/**
 * Test and snapshot a reducer
 */
exports.default = function (description) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
    }

    test(description, function () {
        _assertions.reducer.apply(undefined, args);
    });
};

/**
 * Prepare a function to test and snapshot a reducer
 */


var reducerTestFactory = exports.reducerTestFactory = function reducerTestFactory(tested) {
    return function (description) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            args[_key2 - 1] = arguments[_key2];
        }

        // If we have multiple things to test and received a callback
        // pass the wrapped snapshot function to it
        if (typeof args[0] === 'function') {
            var _ret = function () {
                var asserter = function asserter() {
                    for (var _len3 = arguments.length, assertionArgs = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                        assertionArgs[_key3] = arguments[_key3];
                    }

                    return _assertions.reducer.apply(undefined, [tested].concat(assertionArgs));
                };
                test(description, function () {
                    return args[0](asserter);
                });

                return {
                    v: void 0
                };
            }();

            if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
        }

        test(description, function () {
            return _assertions.reducer.apply(undefined, [tested].concat(args));
        });
    };
};